=== debian/changelog ===
rfone-host (1.0.2-1) experimental; urgency=medium

  * New package (Closes: 1111685)

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 13 Oct 2025 20:28:53 -0400
