=== debian/changelog ===
rfone-host (1.0.3-1) unstable; urgency=medium

  * New upstream release

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 20 Oct 2025 22:49:03 -0400
