=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
                pkgconf
 Standards-Version: 4.7.2
 Rules-Requires-Root: no
-Homepage: https://www.hydrasdr.com
+Homepage: https://hydrasdr.com
 Vcs-Browser: https://salsa.debian.org/debian-hamradio-team/rfone-host
 Vcs-Git: https://salsa.debian.org/debian-hamradio-team/rfone-host.git
 
@@ -18,7 +18,7 @@
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, libhydrasdr0 (= ${binary:Version}), ${misc:Depends}
-Description: HF+VHF software defined radio receiver - user runtime
+Description: HydraSDR RFOne software defined radio receiver - user runtime
  HydraSDR RFOne is an open source Software Defined Radio that can
  receive 24-1850 MHz.
  It is a High Speed USB device powered by the USB bus.
@@ -36,7 +36,7 @@
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
 Depends: libhydrasdr0 (= ${binary:Version}), ${misc:Depends}
-Description: HF+VHF software defined radio receiver - development
+Description: HydraSDR RFOne software defined radio receiver - development
  HydraSDR RFOne is an open source Software Defined Radio that can
  receive 24-1850 MHz.
  It is a High Speed USB device powered by the USB bus.
@@ -49,7 +49,7 @@
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Multi-Arch: same
-Description: HF+VHF software defined radio receiver - library
+Description: HydraSDR RFOne software defined radio receiver - library
  HydraSDR RFOne is an open source Software Defined Radio that can
  receive 24-1850 MHz.
  It is a High Speed USB device powered by the USB bus.
