=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%rfone-host_$1.orig.tar.gz%" \
 https://github.com/hydrasdr/rfone_host/tags \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
